package gui.sections;

import gui.GuiManager;

import javax.swing.JPanel;

/**
 * A Section is a Panel. This applet is split into different sections and
 * each of them has a different purpose.
 */
public abstract class Section extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private GuiManager guiManager;
	
	/**
	 * @see JPanel
	 */
	public Section(){
		super();
	}

	/**
	 * Standard constructor
	 * @param guiManager
	 */
	public Section(GuiManager guiManager){
		super();
		this.guiManager=guiManager;
	}

	/**
	 * Returns the guiMnager
	 * @return guiManager
	 */
	public GuiManager getGuiManager() {
		return guiManager;
	}
}
