package gui.hough;

import houghtransform.HoughCircles;
import ij.ImagePlus;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class ImageSpaceWithCircles extends ImagePanel implements MouseMotionListener {

	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6075003308745147883L;
	protected HoughCircles houghCircles;
	protected HashMap<Integer,List<Point>> houghPoints;
	protected ImagePlus overlayedImage;
	private int radiusShown;

	public ImageSpaceWithCircles(ImagePlus imp,int radmin, int radmax,int radiusShown) {
		super(imp, 1);
		this.radiusShown=radiusShown;
		this.houghPoints = new HashMap<Integer,List<Point>>();
		this.houghCircles = new HoughCircles(imp,radmax-radmin);
		for(int radius=radmin;radius<=radmax;radius++){
				this.houghCircles.fillHoughSpace(radius,radmin);
		}
	}
	public void drawHoughCircles(Point highlightHoughPoint){
		this.houghPoints.clear();
		
		if (highlightHoughPoint != null){
			ArrayList<Point> al=new ArrayList<Point>();
			al.add(highlightHoughPoint);
			this.houghPoints.put(radiusShown,al);
		}
		fireImageChanged();
	}
	public void mouseMoved(MouseEvent e){
		
		if(e.getSource()==this) return;
		
		if(e.getSource() instanceof HoughSpaceMaxima || e.getSource() instanceof HoughSpaceImageEdit) {
			
			ImagePanel ip = (ImagePanel)e.getSource();
			Point ipos = ip.screenToImage(new Point(e.getX(),e.getY()));
			this.drawHoughCircles(ipos);
		}
	}
	public void mouseDragged(MouseEvent arg0) {
		
	}
	protected void paintComponent(Graphics g) {
		this.overlayedImage = this.houghCircles.getImageWithHoughCircles(houghPoints);
		super.paintComponent(g);
		Graphics2D g2d=(Graphics2D)g;
		g2d.drawImage(this.overlayedImage.getImage(), this.affineTranform, null);
	}
}
